From 6aa7de059173a986114ac43b8f50b297a86f09a8 Mon Sep 17 00:00:00 2001
From: Mark Rutland <mark.rutland@arm.com>
Date: Mon, 23 Oct 2017 14:07:29 -0700
Subject: [PATCH] locking/atomics: COCCINELLE/treewide: Convert trivial
 ACCESS_ONCE() patterns to READ_ONCE()/WRITE_ONCE()
Git-commit: 6aa7de059173a986114ac43b8f50b297a86f09a8
Patch-mainline: v4.15-rc1
References: bsc#1093023

Please do not apply this to mainline directly, instead please re-run the
coccinelle script shown below and apply its output.

For several reasons, it is desirable to use {READ,WRITE}_ONCE() in
preference to ACCESS_ONCE(), and new code is expected to use one of the
former. So far, there's been no reason to change most existing uses of
ACCESS_ONCE(), as these aren't harmful, and changing them results in
churn.

However, for some features, the read/write distinction is critical to
correct operation. To distinguish these cases, separate read/write
accessors must be used. This patch migrates (most) remaining
ACCESS_ONCE() instances to {READ,WRITE}_ONCE(), using the following
coccinelle script:

----
// Convert trivial ACCESS_ONCE() uses to equivalent READ_ONCE() and
// WRITE_ONCE()

// $ make coccicheck COCCI=/home/mark/once.cocci SPFLAGS="--include-headers" MODE=patch

virtual patch

@ depends on patch @
expression E1, E2;
@@

- ACCESS_ONCE(E1) = E2
+ WRITE_ONCE(E1, E2)

@ depends on patch @
expression E;
@@

- ACCESS_ONCE(E)
+ READ_ONCE(E)
----

(Coly Li: rebased for SLE15 kernel, partial port drivers/gpu/drm/amd/amdgpu/amdgpu_gem.c)

Signed-off-by: Mark Rutland <mark.rutland@arm.com>
Signed-off-by: Paul E. McKenney <paulmck@linux.vnet.ibm.com>
Cc: Linus Torvalds <torvalds@linux-foundation.org>
Cc: Peter Zijlstra <peterz@infradead.org>
Cc: Thomas Gleixner <tglx@linutronix.de>
Cc: davem@davemloft.net
Cc: linux-arch@vger.kernel.org
Cc: mpe@ellerman.id.au
Cc: shuah@kernel.org
Cc: snitzer@redhat.com
Cc: thor.thayer@linux.intel.com
Cc: tj@kernel.org
Cc: viro@zeniv.linux.org.uk
Cc: will.deacon@arm.com
Link: http://lkml.kernel.org/r/1508792849-3115-19-git-send-email-paulmck@linux.vnet.ibm.com
Signed-off-by: Ingo Molnar <mingo@kernel.org>
Signed-off-by: Coly Li <colyli@suse.de>

---
 arch/arc/kernel/smp.c                                   |    2 
 arch/arm/include/asm/spinlock.h                         |    2 
 arch/arm/mach-tegra/cpuidle-tegra20.c                   |    2 
 arch/arm/vdso/vgettimeofday.c                           |    2 
 arch/ia64/include/asm/spinlock.h                        |    8 +--
 arch/mips/include/asm/vdso.h                            |    2 
 arch/mips/kernel/pm-cps.c                               |    2 
 arch/mn10300/kernel/mn10300-serial.c                    |    4 -
 arch/parisc/include/asm/atomic.h                        |    2 
 arch/powerpc/platforms/powernv/opal-msglog.c            |    2 
 arch/s390/include/asm/spinlock.h                        |    6 +-
 arch/s390/lib/spinlock.c                                |   16 +++----
 arch/sparc/include/asm/atomic_32.h                      |    2 
 arch/tile/gxio/dma_queue.c                              |    4 -
 arch/tile/include/gxio/dma_queue.h                      |    2 
 arch/tile/kernel/ptrace.c                               |    2 
 arch/x86/entry/common.c                                 |    2 
 arch/x86/entry/vdso/vclock_gettime.c                    |    2 
 arch/x86/events/core.c                                  |    2 
 arch/x86/include/asm/vgtod.h                            |    2 
 arch/x86/kernel/espfix_64.c                             |    6 +-
 arch/x86/kernel/nmi.c                                   |    2 
 arch/x86/kvm/mmu.c                                      |    4 -
 arch/x86/kvm/page_track.c                               |    2 
 arch/x86/xen/p2m.c                                      |    2 
 arch/xtensa/platforms/xtfpga/lcd.c                      |   14 +++---
 block/blk-wbt.c                                         |    2 
 drivers/base/core.c                                     |    2 
 drivers/base/power/runtime.c                            |    4 -
 drivers/char/random.c                                   |    4 -
 drivers/clocksource/bcm2835_timer.c                     |    2 
 drivers/crypto/caam/jr.c                                |    4 -
 drivers/crypto/nx/nx-842-powernv.c                      |    2 
 drivers/firewire/ohci.c                                 |   10 +---
 drivers/gpu/drm/amd/amdgpu/amdgpu_fence.c               |    4 -
 drivers/gpu/drm/amd/amdgpu/amdgpu_gem.c                 |    4 -
 drivers/gpu/drm/amd/scheduler/gpu_scheduler.c           |    2 
 drivers/gpu/drm/radeon/radeon_gem.c                     |    4 -
 drivers/gpu/drm/vmwgfx/vmwgfx_surface.c                 |    2 
 drivers/infiniband/hw/hfi1/file_ops.c                   |    2 
 drivers/infiniband/hw/hfi1/pio.c                        |    6 +-
 drivers/infiniband/hw/hfi1/ruc.c                        |    2 
 drivers/infiniband/hw/hfi1/sdma.c                       |    8 +--
 drivers/infiniband/hw/hfi1/sdma.h                       |    2 
 drivers/infiniband/hw/hfi1/uc.c                         |    4 -
 drivers/infiniband/hw/hfi1/ud.c                         |    4 -
 drivers/infiniband/hw/hfi1/user_sdma.c                  |    8 +--
 drivers/infiniband/hw/qib/qib_ruc.c                     |    2 
 drivers/infiniband/hw/qib/qib_uc.c                      |    4 -
 drivers/infiniband/hw/qib/qib_ud.c                      |    4 -
 drivers/infiniband/sw/rdmavt/qp.c                       |    6 +-
 drivers/input/misc/regulator-haptic.c                   |    2 
 drivers/md/dm-bufio.c                                   |   10 ++--
 drivers/md/dm-kcopyd.c                                  |    4 -
 drivers/md/dm-stats.c                                   |   36 ++++++++--------
 drivers/md/dm-switch.c                                  |    2 
 drivers/md/dm-thin.c                                    |    2 
 drivers/md/dm-verity-target.c                           |    2 
 drivers/md/dm.c                                         |    4 -
 drivers/md/md.c                                         |    2 
 drivers/md/raid5.c                                      |    2 
 drivers/misc/mic/scif/scif_rb.c                         |    8 +--
 drivers/misc/mic/scif/scif_rma_list.c                   |    2 
 drivers/net/bonding/bond_alb.c                          |    2 
 drivers/net/bonding/bond_main.c                         |    6 +-
 drivers/net/ethernet/chelsio/cxgb4/sge.c                |    4 -
 drivers/net/ethernet/emulex/benet/be_main.c             |    2 
 drivers/net/ethernet/hisilicon/hip04_eth.c              |    4 -
 drivers/net/ethernet/intel/i40e/i40e_debugfs.c          |    4 -
 drivers/net/ethernet/intel/i40e/i40e_ethtool.c          |    2 
 drivers/net/ethernet/intel/i40e/i40e_main.c             |    4 -
 drivers/net/ethernet/intel/i40e/i40e_ptp.c              |    4 -
 drivers/net/ethernet/intel/igb/e1000_regs.h             |    2 
 drivers/net/ethernet/intel/igb/igb_main.c               |    2 
 drivers/net/ethernet/intel/ixgbe/ixgbe_common.h         |    4 -
 drivers/net/ethernet/intel/ixgbe/ixgbe_main.c           |    8 +--
 drivers/net/ethernet/intel/ixgbe/ixgbe_ptp.c            |    4 -
 drivers/net/ethernet/intel/ixgbevf/ixgbevf_main.c       |    2 
 drivers/net/ethernet/intel/ixgbevf/vf.h                 |    2 
 drivers/net/ethernet/mellanox/mlx4/en_tx.c              |   12 ++---
 drivers/net/ethernet/neterion/vxge/vxge-main.c          |    2 
 drivers/net/ethernet/sfc/ef10.c                         |   10 ++--
 drivers/net/ethernet/sfc/efx.c                          |    4 -
 drivers/net/ethernet/sfc/falcon/efx.c                   |    4 -
 drivers/net/ethernet/sfc/falcon/falcon.c                |    4 -
 drivers/net/ethernet/sfc/falcon/farch.c                 |    8 +--
 drivers/net/ethernet/sfc/falcon/nic.h                   |    6 +-
 drivers/net/ethernet/sfc/falcon/tx.c                    |    6 +-
 drivers/net/ethernet/sfc/farch.c                        |    8 +--
 drivers/net/ethernet/sfc/nic.h                          |    6 +-
 drivers/net/ethernet/sfc/ptp.c                          |   10 ++--
 drivers/net/ethernet/sfc/tx.c                           |    6 +-
 drivers/net/ethernet/sun/niu.c                          |    4 -
 drivers/net/tap.c                                       |    2 
 drivers/net/tun.c                                       |    4 -
 drivers/net/wireless/ath/ath5k/desc.c                   |    8 +--
 drivers/net/wireless/broadcom/brcm80211/brcmfmac/sdio.c |    2 
 drivers/net/wireless/intel/iwlwifi/mvm/ops.c            |    2 
 drivers/net/wireless/intel/iwlwifi/mvm/tx.c             |    4 -
 drivers/net/wireless/intel/iwlwifi/pcie/rx.c            |    2 
 drivers/net/wireless/intel/iwlwifi/pcie/trans.c         |   10 ++--
 drivers/net/wireless/mac80211_hwsim.c                   |    4 -
 drivers/scsi/qla2xxx/qla_target.c                       |    2 
 drivers/target/target_core_user.c                       |    2 
 drivers/usb/class/cdc-wdm.c                             |    2 
 drivers/usb/core/devio.c                                |    2 
 drivers/usb/core/sysfs.c                                |    4 -
 drivers/usb/gadget/udc/gr_udc.c                         |    4 -
 drivers/usb/host/ohci-hcd.c                             |    2 
 drivers/usb/host/uhci-hcd.h                             |    4 -
 drivers/vfio/vfio.c                                     |    2 
 drivers/vhost/scsi.c                                    |    2 
 fs/aio.c                                                |    2 
 fs/buffer.c                                             |    3 -
 fs/crypto/keyinfo.c                                     |    2 
 fs/direct-io.c                                          |    2 
 fs/exec.c                                               |    2 
 fs/fcntl.c                                              |    2 
 fs/fs_pin.c                                             |    4 -
 fs/fuse/dev.c                                           |    2 
 fs/inode.c                                              |    2 
 fs/namei.c                                              |    4 -
 fs/namespace.c                                          |    2 
 fs/nfs/dir.c                                            |    8 +--
 fs/proc/array.c                                         |    2 
 fs/proc_namespace.c                                     |    2 
 fs/splice.c                                             |    2 
 fs/userfaultfd.c                                        |    8 +--
 fs/xfs/xfs_log_priv.h                                   |    4 -
 include/linux/bitops.h                                  |    4 -
 include/linux/dynamic_queue_limits.h                    |    2 
 include/linux/huge_mm.h                                 |    2 
 include/linux/if_team.h                                 |    2 
 include/linux/llist.h                                   |    2 
 include/linux/pm_runtime.h                              |    2 
 include/net/ip_vs.h                                     |    6 +-
 kernel/acct.c                                           |    4 -
 kernel/events/core.c                                    |    6 +-
 kernel/events/ring_buffer.c                             |    2 
 kernel/exit.c                                           |    2 
 kernel/trace/ring_buffer.c                              |    2 
 kernel/trace/trace.h                                    |    2 
 kernel/trace/trace_stack.c                              |    2 
 kernel/user_namespace.c                                 |    2 
 lib/assoc_array.c                                       |   20 ++++----
 lib/dynamic_queue_limits.c                              |    2 
 lib/llist.c                                             |    2 
 lib/vsprintf.c                                          |    4 -
 mm/huge_memory.c                                        |    2 
 net/core/dev.c                                          |    2 
 net/core/pktgen.c                                       |    2 
 net/ipv4/inet_fragment.c                                |    2 
 net/ipv4/route.c                                        |    2 
 net/ipv4/tcp_output.c                                   |    2 
 net/ipv4/udp.c                                          |    4 -
 net/ipv6/ip6_tunnel.c                                   |    8 +--
 net/ipv6/udp.c                                          |    4 -
 net/llc/llc_input.c                                     |    4 -
 net/mac80211/sta_info.c                                 |    2 
 net/netlabel/netlabel_calipso.c                         |    2 
 net/wireless/nl80211.c                                  |    2 
 sound/firewire/amdtp-am824.c                            |    6 +-
 sound/firewire/amdtp-stream.c                           |   23 ++++------
 sound/firewire/amdtp-stream.h                           |    2 
 sound/firewire/digi00x/amdtp-dot.c                      |    6 +-
 sound/firewire/fireface/amdtp-ff.c                      |    4 -
 sound/firewire/fireface/ff-midi.c                       |   10 ++--
 sound/firewire/fireface/ff-transaction.c                |    8 +--
 sound/firewire/isight.c                                 |   18 ++++----
 sound/firewire/motu/amdtp-motu.c                        |    4 -
 sound/firewire/oxfw/oxfw-scs1x.c                        |   12 ++---
 sound/firewire/tascam/amdtp-tascam.c                    |    4 -
 sound/firewire/tascam/tascam-transaction.c              |    6 +-
 sound/soc/xtensa/xtfpga-i2s.c                           |    6 +-
 sound/usb/bcd2000/bcd2000.c                             |    4 -
 tools/arch/x86/include/asm/atomic.h                     |    2 
 tools/include/asm-generic/atomic-gcc.h                  |    2 
 tools/perf/util/auxtrace.h                              |    4 -
 tools/perf/util/session.h                               |    2 
 virt/kvm/kvm_main.c                                     |    2 
 180 files changed, 383 insertions(+), 385 deletions(-)

--- a/arch/arc/kernel/smp.c
+++ b/arch/arc/kernel/smp.c
@@ -245,7 +245,7 @@ static void ipi_send_msg_one(int cpu, en
 	 * and read back old value
 	 */
 	do {
-		new = old = ACCESS_ONCE(*ipi_data_ptr);
+		new = old = READ_ONCE(*ipi_data_ptr);
 		new |= 1U << msg;
 	} while (cmpxchg(ipi_data_ptr, old, new) != old);
 
--- a/arch/arm/include/asm/spinlock.h
+++ b/arch/arm/include/asm/spinlock.h
@@ -89,7 +89,7 @@ static inline void arch_spin_lock(arch_s
 
 	while (lockval.tickets.next != lockval.tickets.owner) {
 		wfe();
-		lockval.tickets.owner = ACCESS_ONCE(lock->tickets.owner);
+		lockval.tickets.owner = READ_ONCE(lock->tickets.owner);
 	}
 
 	smp_mb();
--- a/arch/arm/mach-tegra/cpuidle-tegra20.c
+++ b/arch/arm/mach-tegra/cpuidle-tegra20.c
@@ -179,7 +179,7 @@ static int tegra20_idle_lp2_coupled(stru
 	bool entered_lp2 = false;
 
 	if (tegra_pending_sgi())
-		ACCESS_ONCE(abort_flag) = true;
+		WRITE_ONCE(abort_flag, true);
 
 	cpuidle_coupled_parallel_barrier(dev, &abort_barrier);
 
--- a/arch/arm/vdso/vgettimeofday.c
+++ b/arch/arm/vdso/vgettimeofday.c
@@ -35,7 +35,7 @@ static notrace u32 __vdso_read_begin(con
 {
 	u32 seq;
 repeat:
-	seq = ACCESS_ONCE(vdata->seq_count);
+	seq = READ_ONCE(vdata->seq_count);
 	if (seq & 1) {
 		cpu_relax();
 		goto repeat;
--- a/arch/ia64/include/asm/spinlock.h
+++ b/arch/ia64/include/asm/spinlock.h
@@ -61,7 +61,7 @@ static __always_inline void __ticket_spi
 
 static __always_inline int __ticket_spin_trylock(arch_spinlock_t *lock)
 {
-	int tmp = ACCESS_ONCE(lock->lock);
+	int tmp = READ_ONCE(lock->lock);
 
 	if (!(((tmp >> TICKET_SHIFT) ^ tmp) & TICKET_MASK))
 		return ia64_cmpxchg(acq, &lock->lock, tmp, tmp + 1, sizeof (tmp)) == tmp;
@@ -73,7 +73,7 @@ static __always_inline void __ticket_spi
 	unsigned short	*p = (unsigned short *)&lock->lock + 1, tmp;
 
 	asm volatile ("ld2.bias %0=[%1]" : "=r"(tmp) : "r"(p));
-	ACCESS_ONCE(*p) = (tmp + 2) & ~1;
+	WRITE_ONCE(*p, (tmp + 2) & ~1);
 }
 
 static __always_inline void __ticket_spin_unlock_wait(arch_spinlock_t *lock)
@@ -94,14 +94,14 @@ static __always_inline void __ticket_spi
 
 static inline int __ticket_spin_is_locked(arch_spinlock_t *lock)
 {
-	long tmp = ACCESS_ONCE(lock->lock);
+	long tmp = READ_ONCE(lock->lock);
 
 	return !!(((tmp >> TICKET_SHIFT) ^ tmp) & TICKET_MASK);
 }
 
 static inline int __ticket_spin_is_contended(arch_spinlock_t *lock)
 {
-	long tmp = ACCESS_ONCE(lock->lock);
+	long tmp = READ_ONCE(lock->lock);
 
 	return ((tmp - (tmp >> TICKET_SHIFT)) & TICKET_MASK) > 1;
 }
--- a/arch/mips/include/asm/vdso.h
+++ b/arch/mips/include/asm/vdso.h
@@ -99,7 +99,7 @@ static inline u32 vdso_data_read_begin(c
 	u32 seq;
 
 	while (true) {
-		seq = ACCESS_ONCE(data->seq_count);
+		seq = READ_ONCE(data->seq_count);
 		if (likely(!(seq & 1))) {
 			/* Paired with smp_wmb() in vdso_data_write_*(). */
 			smp_rmb();
--- a/arch/mips/kernel/pm-cps.c
+++ b/arch/mips/kernel/pm-cps.c
@@ -167,7 +167,7 @@ int cps_pm_enter_state(enum cps_pm_state
 	nc_core_ready_count = nc_addr;
 
 	/* Ensure ready_count is zero-initialised before the assembly runs */
-	ACCESS_ONCE(*nc_core_ready_count) = 0;
+	WRITE_ONCE(*nc_core_ready_count, 0);
 	coupled_barrier(&per_cpu(pm_barrier, core), online);
 
 	/* Run the generated entry code */
--- a/arch/mn10300/kernel/mn10300-serial.c
+++ b/arch/mn10300/kernel/mn10300-serial.c
@@ -543,7 +543,7 @@ static void mn10300_serial_receive_inter
 
 try_again:
 	/* pull chars out of the hat */
-	ix = ACCESS_ONCE(port->rx_outp);
+	ix = READ_ONCE(port->rx_outp);
 	if (CIRC_CNT(port->rx_inp, ix, MNSC_BUFFER_SIZE) == 0) {
 		if (push && !tport->low_latency)
 			tty_flip_buffer_push(tport);
@@ -1724,7 +1724,7 @@ static int mn10300_serial_poll_get_char(
 	if (mn10300_serial_int_tbl[port->rx_irq].port != NULL) {
 		do {
 			/* pull chars out of the hat */
-			ix = ACCESS_ONCE(port->rx_outp);
+			ix = READ_ONCE(port->rx_outp);
 			if (CIRC_CNT(port->rx_inp, ix, MNSC_BUFFER_SIZE) == 0)
 				return NO_POLL_CHAR;
 
--- a/arch/parisc/include/asm/atomic.h
+++ b/arch/parisc/include/asm/atomic.h
@@ -258,7 +258,7 @@ atomic64_set(atomic64_t *v, s64 i)
 static __inline__ s64
 atomic64_read(const atomic64_t *v)
 {
-	return ACCESS_ONCE((v)->counter);
+	return READ_ONCE((v)->counter);
 }
 
 #define atomic64_inc(v)		(atomic64_add(   1,(v)))
--- a/arch/powerpc/platforms/powernv/opal-msglog.c
+++ b/arch/powerpc/platforms/powernv/opal-msglog.c
@@ -43,7 +43,7 @@ ssize_t opal_msglog_copy(char *to, loff_
 	if (!opal_memcons)
 		return -ENODEV;
 
-	out_pos = be32_to_cpu(ACCESS_ONCE(opal_memcons->out_pos));
+	out_pos = be32_to_cpu(READ_ONCE(opal_memcons->out_pos));
 
 	/* Now we've read out_pos, put a barrier in before reading the new
 	 * data it points to in conbuf. */
--- a/arch/s390/include/asm/spinlock.h
+++ b/arch/s390/include/asm/spinlock.h
@@ -136,14 +136,14 @@ extern int _raw_write_trylock_retry(arch
 
 static inline int arch_read_trylock_once(arch_rwlock_t *rw)
 {
-	int old = ACCESS_ONCE(rw->lock);
+	int old = READ_ONCE(rw->lock);
 	return likely(old >= 0 &&
 		      __atomic_cmpxchg_bool(&rw->lock, old, old + 1));
 }
 
 static inline int arch_write_trylock_once(arch_rwlock_t *rw)
 {
-	int old = ACCESS_ONCE(rw->lock);
+	int old = READ_ONCE(rw->lock);
 	return likely(old == 0 &&
 		      __atomic_cmpxchg_bool(&rw->lock, 0, 0x80000000));
 }
@@ -230,7 +230,7 @@ static inline void arch_read_unlock(arch
 	int old;
 
 	do {
-		old = ACCESS_ONCE(rw->lock);
+		old = READ_ONCE(rw->lock);
 	} while (!__atomic_cmpxchg_bool(&rw->lock, old, old - 1));
 }
 
--- a/arch/s390/lib/spinlock.c
+++ b/arch/s390/lib/spinlock.c
@@ -159,8 +159,8 @@ void _raw_read_lock_wait(arch_rwlock_t *
 				smp_yield_cpu(~owner);
 			count = spin_retry;
 		}
-		old = ACCESS_ONCE(rw->lock);
-		owner = ACCESS_ONCE(rw->owner);
+		old = READ_ONCE(rw->lock);
+		owner = READ_ONCE(rw->owner);
 		if (old < 0)
 			continue;
 		if (__atomic_cmpxchg_bool(&rw->lock, old, old + 1))
@@ -175,7 +175,7 @@ int _raw_read_trylock_retry(arch_rwlock_
 	int old;
 
 	while (count-- > 0) {
-		old = ACCESS_ONCE(rw->lock);
+		old = READ_ONCE(rw->lock);
 		if (old < 0)
 			continue;
 		if (__atomic_cmpxchg_bool(&rw->lock, old, old + 1))
@@ -199,8 +199,8 @@ void _raw_write_lock_wait(arch_rwlock_t
 				smp_yield_cpu(~owner);
 			count = spin_retry;
 		}
-		old = ACCESS_ONCE(rw->lock);
-		owner = ACCESS_ONCE(rw->owner);
+		old = READ_ONCE(rw->lock);
+		owner = READ_ONCE(rw->owner);
 		smp_mb();
 		if (old >= 0) {
 			prev = __RAW_LOCK(&rw->lock, 0x80000000, __RAW_OP_OR);
@@ -227,8 +227,8 @@ void _raw_write_lock_wait(arch_rwlock_t
 				smp_yield_cpu(~owner);
 			count = spin_retry;
 		}
-		old = ACCESS_ONCE(rw->lock);
-		owner = ACCESS_ONCE(rw->owner);
+		old = READ_ONCE(rw->lock);
+		owner = READ_ONCE(rw->owner);
 		if (old >= 0 &&
 		    __atomic_cmpxchg_bool(&rw->lock, old, old | 0x80000000))
 			prev = old;
@@ -248,7 +248,7 @@ int _raw_write_trylock_retry(arch_rwlock
 	int old;
 
 	while (count-- > 0) {
-		old = ACCESS_ONCE(rw->lock);
+		old = READ_ONCE(rw->lock);
 		if (old)
 			continue;
 		if (__atomic_cmpxchg_bool(&rw->lock, 0, 0x80000000))
--- a/arch/sparc/include/asm/atomic_32.h
+++ b/arch/sparc/include/asm/atomic_32.h
@@ -29,7 +29,7 @@ int atomic_xchg(atomic_t *, int);
 int __atomic_add_unless(atomic_t *, int, int);
 void atomic_set(atomic_t *, int);
 
-#define atomic_read(v)          ACCESS_ONCE((v)->counter)
+#define atomic_read(v)          READ_ONCE((v)->counter)
 
 #define atomic_add(i, v)	((void)atomic_add_return( (int)(i), (v)))
 #define atomic_sub(i, v)	((void)atomic_add_return(-(int)(i), (v)))
--- a/arch/tile/gxio/dma_queue.c
+++ b/arch/tile/gxio/dma_queue.c
@@ -163,14 +163,14 @@ int __gxio_dma_queue_is_complete(__gxio_
 				 int64_t completion_slot, int update)
 {
 	if (update) {
-		if (ACCESS_ONCE(dma_queue->hw_complete_count) >
+		if (READ_ONCE(dma_queue->hw_complete_count) >
 		    completion_slot)
 			return 1;
 
 		__gxio_dma_queue_update_credits(dma_queue);
 	}
 
-	return ACCESS_ONCE(dma_queue->hw_complete_count) > completion_slot;
+	return READ_ONCE(dma_queue->hw_complete_count) > completion_slot;
 }
 
 EXPORT_SYMBOL_GPL(__gxio_dma_queue_is_complete);
--- a/arch/tile/include/gxio/dma_queue.h
+++ b/arch/tile/include/gxio/dma_queue.h
@@ -121,7 +121,7 @@ static inline int64_t __gxio_dma_queue_r
 		 * if the result is LESS than "hw_complete_count".
 		 */
 		uint64_t complete;
-		complete = ACCESS_ONCE(dma_queue->hw_complete_count);
+		complete = READ_ONCE(dma_queue->hw_complete_count);
 		slot |= (complete & 0xffffffffff000000);
 		if (slot < complete)
 			slot += 0x1000000;
--- a/arch/tile/kernel/ptrace.c
+++ b/arch/tile/kernel/ptrace.c
@@ -255,7 +255,7 @@ long compat_arch_ptrace(struct task_stru
 
 int do_syscall_trace_enter(struct pt_regs *regs)
 {
-	u32 work = ACCESS_ONCE(current_thread_info()->flags);
+	u32 work = READ_ONCE(current_thread_info()->flags);
 
 	if ((work & _TIF_SYSCALL_TRACE) &&
 	    tracehook_report_syscall_entry(regs)) {
--- a/arch/x86/entry/common.c
+++ b/arch/x86/entry/common.c
@@ -74,7 +74,7 @@ static long syscall_trace_enter(struct p
 	if (IS_ENABLED(CONFIG_DEBUG_ENTRY))
 		BUG_ON(regs != task_pt_regs(current));
 
-	work = ACCESS_ONCE(ti->flags) & _TIF_WORK_SYSCALL_ENTRY;
+	work = READ_ONCE(ti->flags) & _TIF_WORK_SYSCALL_ENTRY;
 
 	if (unlikely(work & _TIF_SYSCALL_EMU))
 		emulated = true;
--- a/arch/x86/entry/vdso/vclock_gettime.c
+++ b/arch/x86/entry/vdso/vclock_gettime.c
@@ -318,7 +318,7 @@ int gettimeofday(struct timeval *, struc
 notrace time_t __vdso_time(time_t *t)
 {
 	/* This is atomic on x86 so we don't need any locks. */
-	time_t result = ACCESS_ONCE(gtod->wall_time_sec);
+	time_t result = READ_ONCE(gtod->wall_time_sec);
 
 	if (t)
 		*t = result;
--- a/arch/x86/events/core.c
+++ b/arch/x86/events/core.c
@@ -2093,7 +2093,7 @@ static int x86_pmu_event_init(struct per
 			event->destroy(event);
 	}
 
-	if (ACCESS_ONCE(x86_pmu.attr_rdpmc))
+	if (READ_ONCE(x86_pmu.attr_rdpmc))
 		event->hw.flags |= PERF_X86_EVENT_RDPMC_ALLOWED;
 
 	return err;
--- a/arch/x86/include/asm/vgtod.h
+++ b/arch/x86/include/asm/vgtod.h
@@ -48,7 +48,7 @@ static inline unsigned gtod_read_begin(c
 	unsigned ret;
 
 repeat:
-	ret = ACCESS_ONCE(s->seq);
+	ret = READ_ONCE(s->seq);
 	if (unlikely(ret & 1)) {
 		cpu_relax();
 		goto repeat;
--- a/arch/x86/kernel/espfix_64.c
+++ b/arch/x86/kernel/espfix_64.c
@@ -155,14 +155,14 @@ void init_espfix_ap(int cpu)
 	page = cpu/ESPFIX_STACKS_PER_PAGE;
 
 	/* Did another CPU already set this up? */
-	stack_page = ACCESS_ONCE(espfix_pages[page]);
+	stack_page = READ_ONCE(espfix_pages[page]);
 	if (likely(stack_page))
 		goto done;
 
 	mutex_lock(&espfix_init_mutex);
 
 	/* Did we race on the lock? */
-	stack_page = ACCESS_ONCE(espfix_pages[page]);
+	stack_page = READ_ONCE(espfix_pages[page]);
 	if (stack_page)
 		goto unlock_done;
 
@@ -200,7 +200,7 @@ void init_espfix_ap(int cpu)
 		set_pte(&pte_p[n*PTE_STRIDE], pte);
 
 	/* Job is done for this CPU and any CPU which shares this page */
-	ACCESS_ONCE(espfix_pages[page]) = stack_page;
+	WRITE_ONCE(espfix_pages[page], stack_page);
 
 unlock_done:
 	mutex_unlock(&espfix_init_mutex);
--- a/arch/x86/kernel/nmi.c
+++ b/arch/x86/kernel/nmi.c
@@ -105,7 +105,7 @@ static void nmi_max_handler(struct irq_w
 {
 	struct nmiaction *a = container_of(w, struct nmiaction, irq_work);
 	int remainder_ns, decimal_msecs;
-	u64 whole_msecs = ACCESS_ONCE(a->max_duration);
+	u64 whole_msecs = READ_ONCE(a->max_duration);
 
 	remainder_ns = do_div(whole_msecs, (1000 * 1000));
 	decimal_msecs = remainder_ns / 1000;
--- a/arch/x86/kvm/mmu.c
+++ b/arch/x86/kvm/mmu.c
@@ -443,7 +443,7 @@ static u64 __update_clear_spte_slow(u64
 
 static u64 __get_spte_lockless(u64 *sptep)
 {
-	return ACCESS_ONCE(*sptep);
+	return READ_ONCE(*sptep);
 }
 #else
 union split_spte {
@@ -4819,7 +4819,7 @@ static void kvm_mmu_pte_write(struct kvm
 	 * If we don't have indirect shadow pages, it means no page is
 	 * write-protected, so we can exit simply.
 	 */
-	if (!ACCESS_ONCE(vcpu->kvm->arch.indirect_shadow_pages))
+	if (!READ_ONCE(vcpu->kvm->arch.indirect_shadow_pages))
 		return;
 
 	remote_flush = local_flush = false;
--- a/arch/x86/kvm/page_track.c
+++ b/arch/x86/kvm/page_track.c
@@ -157,7 +157,7 @@ bool kvm_page_track_is_active(struct kvm
 		return false;
 
 	index = gfn_to_index(gfn, slot->base_gfn, PT_PAGE_TABLE_LEVEL);
-	return !!ACCESS_ONCE(slot->arch.gfn_track[mode][index]);
+	return !!READ_ONCE(slot->arch.gfn_track[mode][index]);
 }
 
 void kvm_page_track_cleanup(struct kvm *kvm)
--- a/arch/x86/xen/p2m.c
+++ b/arch/x86/xen/p2m.c
@@ -557,7 +557,7 @@ int xen_alloc_p2m_entry(unsigned long pf
 	if (p2m_top_mfn && pfn < MAX_P2M_PFN) {
 		topidx = p2m_top_index(pfn);
 		top_mfn_p = &p2m_top_mfn[topidx];
-		mid_mfn = ACCESS_ONCE(p2m_top_mfn_p[topidx]);
+		mid_mfn = READ_ONCE(p2m_top_mfn_p[topidx]);
 
 		BUG_ON(virt_to_mfn(mid_mfn) != *top_mfn_p);
 
--- a/arch/xtensa/platforms/xtfpga/lcd.c
+++ b/arch/xtensa/platforms/xtfpga/lcd.c
@@ -34,23 +34,23 @@
 static void lcd_put_byte(u8 *addr, u8 data)
 {
 #ifdef CONFIG_XTFPGA_LCD_8BIT_ACCESS
-	ACCESS_ONCE(*addr) = data;
+	WRITE_ONCE(*addr, data);
 #else
-	ACCESS_ONCE(*addr) = data & 0xf0;
-	ACCESS_ONCE(*addr) = (data << 4) & 0xf0;
+	WRITE_ONCE(*addr, data & 0xf0);
+	WRITE_ONCE(*addr, (data << 4) & 0xf0);
 #endif
 }
 
 static int __init lcd_init(void)
 {
-	ACCESS_ONCE(*LCD_INSTR_ADDR) = LCD_DISPLAY_MODE8BIT;
+	WRITE_ONCE(*LCD_INSTR_ADDR, LCD_DISPLAY_MODE8BIT);
 	mdelay(5);
-	ACCESS_ONCE(*LCD_INSTR_ADDR) = LCD_DISPLAY_MODE8BIT;
+	WRITE_ONCE(*LCD_INSTR_ADDR, LCD_DISPLAY_MODE8BIT);
 	udelay(200);
-	ACCESS_ONCE(*LCD_INSTR_ADDR) = LCD_DISPLAY_MODE8BIT;
+	WRITE_ONCE(*LCD_INSTR_ADDR, LCD_DISPLAY_MODE8BIT);
 	udelay(50);
 #ifndef CONFIG_XTFPGA_LCD_8BIT_ACCESS
-	ACCESS_ONCE(*LCD_INSTR_ADDR) = LCD_DISPLAY_MODE4BIT;
+	WRITE_ONCE(*LCD_INSTR_ADDR, LCD_DISPLAY_MODE4BIT);
 	udelay(50);
 	lcd_put_byte(LCD_INSTR_ADDR, LCD_DISPLAY_MODE4BIT);
 	udelay(50);
--- a/block/blk-wbt.c
+++ b/block/blk-wbt.c
@@ -261,7 +261,7 @@ static inline bool stat_sample_valid(str
 
 static u64 rwb_sync_issue_lat(struct rq_wb *rwb)
 {
-	u64 now, issue = ACCESS_ONCE(rwb->sync_issue);
+	u64 now, issue = READ_ONCE(rwb->sync_issue);
 
 	if (!issue || !rwb->sync_cookie)
 		return 0;
--- a/drivers/base/core.c
+++ b/drivers/base/core.c
@@ -668,7 +668,7 @@ const char *dev_driver_string(const stru
 	 * so be careful about accessing it.  dev->bus and dev->class should
 	 * never change once they are set, so they don't need special care.
 	 */
-	drv = ACCESS_ONCE(dev->driver);
+	drv = READ_ONCE(dev->driver);
 	return drv ? drv->name :
 			(dev->bus ? dev->bus->name :
 			(dev->class ? dev->class->name : ""));
--- a/drivers/base/power/runtime.c
+++ b/drivers/base/power/runtime.c
@@ -134,11 +134,11 @@ unsigned long pm_runtime_autosuspend_exp
 	if (!dev->power.use_autosuspend)
 		goto out;
 
-	autosuspend_delay = ACCESS_ONCE(dev->power.autosuspend_delay);
+	autosuspend_delay = READ_ONCE(dev->power.autosuspend_delay);
 	if (autosuspend_delay < 0)
 		goto out;
 
-	last_busy = ACCESS_ONCE(dev->power.last_busy);
+	last_busy = READ_ONCE(dev->power.last_busy);
 	elapsed = jiffies - last_busy;
 	if (elapsed < 0)
 		goto out;	/* jiffies has wrapped around. */
--- a/drivers/char/random.c
+++ b/drivers/char/random.c
@@ -641,7 +641,7 @@ static void credit_entropy_bits(struct e
 		return;
 
 retry:
-	entropy_count = orig = ACCESS_ONCE(r->entropy_count);
+	entropy_count = orig = READ_ONCE(r->entropy_count);
 	if (nfrac < 0) {
 		/* Debit */
 		entropy_count += nfrac;
@@ -1265,7 +1265,7 @@ static size_t account(struct entropy_sto
 
 	/* Can we pull enough? */
 retry:
-	entropy_count = orig = ACCESS_ONCE(r->entropy_count);
+	entropy_count = orig = READ_ONCE(r->entropy_count);
 	ibytes = nbytes;
 	/* never pull more than available */
 	have_bytes = entropy_count >> (ENTROPY_SHIFT + 3);
--- a/drivers/clocksource/bcm2835_timer.c
+++ b/drivers/clocksource/bcm2835_timer.c
@@ -71,7 +71,7 @@ static irqreturn_t bcm2835_time_interrup
 	if (readl_relaxed(timer->control) & timer->match_mask) {
 		writel_relaxed(timer->match_mask, timer->control);
 
-		event_handler = ACCESS_ONCE(timer->evt.event_handler);
+		event_handler = READ_ONCE(timer->evt.event_handler);
 		if (event_handler)
 			event_handler(&timer->evt);
 		return IRQ_HANDLED;
--- a/drivers/crypto/caam/jr.c
+++ b/drivers/crypto/caam/jr.c
@@ -172,7 +172,7 @@ static void caam_jr_dequeue(unsigned lon
 
 	while (rd_reg32(&jrp->rregs->outring_used)) {
 
-		head = ACCESS_ONCE(jrp->head);
+		head = READ_ONCE(jrp->head);
 
 		spin_lock(&jrp->outlock);
 
@@ -341,7 +341,7 @@ int caam_jr_enqueue(struct device *dev,
 	spin_lock_bh(&jrp->inplock);
 
 	head = jrp->head;
-	tail = ACCESS_ONCE(jrp->tail);
+	tail = READ_ONCE(jrp->tail);
 
 	if (!rd_reg32(&jrp->rregs->inpring_avail) ||
 	    CIRC_SPACE(head, tail, JOBR_DEPTH) <= 0) {
--- a/drivers/crypto/nx/nx-842-powernv.c
+++ b/drivers/crypto/nx/nx-842-powernv.c
@@ -173,7 +173,7 @@ static int wait_for_csb(struct nx842_wor
 	ktime_t start = wmem->start, now = ktime_get();
 	ktime_t timeout = ktime_add_ms(start, CSB_WAIT_MAX);
 
-	while (!(ACCESS_ONCE(csb->flags) & CSB_V)) {
+	while (!(READ_ONCE(csb->flags) & CSB_V)) {
 		cpu_relax();
 		now = ktime_get();
 		if (ktime_after(now, timeout))
